package com.emoon.system.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.emoon.common.core.constant.SystemConstants;
import com.emoon.common.mybatis.core.mapper.BaseMapperPlus;
import com.emoon.system.domain.SysMenuDo;
import com.emoon.system.domain.vo.SysMenuVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 菜单表 数据层
 *
 * @author wangkang
 */
@Mapper
public interface SysMenuMapper extends BaseMapperPlus<SysMenuDo, SysMenuVo> {

    /**
     * 根据用户查询系统菜单列表
     *
     * @param queryWrapper 查询条件
     * @return 菜单列表
     */
    List<SysMenuDo> selectMenuListByUserId(@Param(Constants.WRAPPER) Wrapper<SysMenuDo> queryWrapper);

    /**
     * 根据用户ID查询权限
     *
     * @param userId 用户ID
     * @return 权限列表
     */
    List<String> selectMenuPermsByUserId(Long userId);

    /**
     * 根据角色ID查询权限
     *
     * @param roleId 角色ID
     * @return 权限列表
     */
    List<String> selectMenuPermsByRoleId(Long roleId);

    /**
     * 根据用户ID查询菜单
     *
     * @return 菜单列表
     */
    default List<SysMenuDo> selectMenuTreeAll() {
        LambdaQueryWrapper<SysMenuDo> lqw = new LambdaQueryWrapper<SysMenuDo>()
            .in(SysMenuDo::getMenuType, SystemConstants.TYPE_DIR, SystemConstants.TYPE_MENU)
            .eq(SysMenuDo::getStatus, SystemConstants.NORMAL)
            .orderByAsc(SysMenuDo::getParentId)
            .orderByAsc(SysMenuDo::getOrderNum);
        return this.selectList(lqw);
    }

    /**
     * 根据用户ID查询菜单
     *
     * @param userId 用户ID
     * @return 菜单列表
     */
    List<SysMenuDo> selectMenuTreeByUserId(Long userId);

    /**
     * 根据角色ID查询菜单树信息
     *
     * @param roleId            角色ID
     * @param menuCheckStrictly 菜单树选择项是否关联显示
     * @return 选中菜单列表
     */
    List<Long> selectMenuListByRoleId(@Param("roleId") Long roleId, @Param("menuCheckStrictly") boolean menuCheckStrictly);

}
